"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableName = exports.cancelCombinator = void 0;
function cancelCombinator(fn) {
    const cancelFnArray = [];
    const saveCancelFn = (promise) => {
        if (promise.cancel) {
            cancelFnArray.push(promise.cancel);
        }
        return promise;
    };
    const promise = fn(saveCancelFn);
    promise.cancel = () => Promise.all(cancelFnArray.map(cancel => cancel()));
    return promise;
}
exports.cancelCombinator = cancelCombinator;
class TableName {
    schema;
    name;
    constructor(schema, name) {
        this.schema = schema;
        this.name = name;
    }
    static split(tableName) {
        const parts = tableName.split('.');
        return new TableName(parts[0], parts.slice(1).join('.'));
    }
    join() {
        return `${this.schema}.${this.name}`;
    }
}
exports.TableName = TableName;
//# sourceMappingURL=utils.js.map